!Module to read the picking table for PZ
! Pick file must be sorted by common receiver location
module pick_read
 type pick_entry
  real (kind=8), dimension(2) :: t
  real (kind=8) :: gx,gy
  real (kind=8), dimension(2) :: sx,sy
 end type pick_entry

contains
 subroutine decode_pick_file (filename,pick_list)
    implicit none
    character*(*), intent(in) :: filename
    type(pick_entry), intent(inout), pointer :: pick_list(:)

    character*256 :: line_buffer
    integer :: open_stat,read_stat
    integer :: line_count, rec_count
    logical :: first
    type(pick_entry) :: pick, previous_pick
    !Open the file to be read and count the number of receivers
    open(file=filename,unit=22,form='formatted', status='old', iostat=open_stat)
    if (open_stat .ne. 0 ) then
       write(0,*) "Cannot read the input file"
       return
    endif
    
    read_stat=0
    line_count=0
    rec_count=0
    first=.true.
    do while (read_stat == 0)
     read(unit=22,fmt='(A)',iostat=read_stat) line_buffer
     if (read_stat == 0) then
        if (line_buffer(1:1)=='#') cycle
        line_count = line_count + 1
        read(line_buffer,*) pick%t(1), pick%sx(1), pick%sy(1), pick%gx, pick%gy
        if (first) then
            previous_pick=pick
            first=.false.
            rec_count= rec_count + 1            
        endif 
        if (pick%gx .ne. previous_pick%gx .or. pick%gy .ne. previous_pick%gy) then
           rec_count= rec_count + 1
        endif
        previous_pick=pick
     endif
    enddo


    rewind(unit=22)
    if (rec_count > 0) then
        allocate(pick_list(1:rec_count))
        read_stat=0
        first=.true.
        rec_count=0
        do while (read_stat == 0)
           read(unit=22,fmt='(A)',iostat=read_stat) line_buffer
           if (read_stat == 0) then
             if (line_buffer(1:1)=='#') cycle
             read(line_buffer,*) pick%t(1), pick%sx(1), pick%sy(1), pick%gx, pick%gy
             if (first) then
                previous_pick=pick
                first=.false.
                rec_count= rec_count + 1
                pick_list(rec_count)=pick
             endif 
             if (pick%gx .ne. previous_pick%gx .or. pick%gy .ne. previous_pick%gy) then
                 rec_count= rec_count + 1
                 pick_list(rec_count)=pick
             else
                 pick_list(rec_count)%sx(2)=pick%sx(1) 
                 pick_list(rec_count)%sy(2)=pick%sy(1)
                 pick_list(rec_count)%t(2)=pick%t(1)
             endif
             previous_pick=pick
           endif
        enddo
    endif


    close(unit=22)
    return
 end subroutine decode_pick_file
end module pick_read




