!Subroutine that resamples the filter to match the data sampling rate
module resample

 implicit none

contains

subroutine filt_resamp(d1filt,d1data, aa, m, mpad)
  use fourier

  integer , intent(in)           :: m
  integer, intent(out)           :: mpad
  real             	         :: d1filt, d1data, sign1
  real, dimension(:)  ,intent (inout) , allocatable          :: aa
  complex,  dimension (:,:), allocatable :: caa, caalong  

  sign1 = 1.
  mpad = m
  if (abs(d1data-2.*d1filt) < 0.001 ) then  
  ! Case where filter sampling is twice as dense as data sampling
  ! We resample the filter to the data sampling rate
        mpad = m + mod(4-mod(m, 4), 4)
        allocate(caa(mpad,1))
        caa = 0.  
        caa(1:m,1)= aa
        call ft_init(mpad,1)
        !FFT  
        call ft1axis(.false., sign1, caa)
        caa(mpad/4+2:3*mpad/4+1, 1) = 0.
        call ft1axis(.true., sign1, caa)
!        deallocate(aa)
!        allocate(aa(1:mpad/2))
        aa = 0.
        aa(1:mpad/2) = real(caa(1:mpad:2,1))
        mpad = m
        deallocate(caa)
        call ft_destroy()
  endif
  if (abs(d1filt-2.*d1data) < 0.001) then
  ! Case where data sampling is twice as dense as filter sampling
  ! We resample the filter to the data sampling rate
       mpad = m*2
       allocate(caa(m,1))
       caa = 0.
       caa(:,1)= aa
       call ft_init(m,1)
       !FFT  
       call ft1axis(.false., sign1, caa)
       allocate(caalong(mpad,1))
       caalong=0.
       caalong(1:m/2+1,1)=caa(1:m/2+1,1)
       caalong((mpad-m/2+1):mpad,1)=caa(m/2+2:m,1)
       caalong(:,1) = caalong(:,1)*sqrt(1.*m)/sqrt(1.*mpad)!check normalization factor
       call ft_destroy()
       call ft_init(mpad,1)
       !FFT  
       call ft1axis(.true., sign1, caalong)
       deallocate(aa)
       allocate(aa(mpad))
       aa=real(caalong(:,1))
       deallocate(caa)
       call ft_destroy()
  endif
end subroutine

end module
